Package org.jfree.layouting.normalizer

## Class ChainingNormalizer

- java.lang.Object
- - org.jfree.layouting.normalizer.ChainingNormalizer

- All Implemented Interfaces:
    `Normalizer`, `StatefullComponent`

      public class ChainingNormalizer
      extends java.lang.Object
      implements Normalizer

  Creation-Date: 16.06.2006, 14:34:44
  Author:
    Thomas Morgner

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ChainingNormalizer​(Normalizer normalizer)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `addText​(java.lang.String text)` | Adds text content to the current element.
    `void` | `commitCalls​()` |
    `void` | `endDocument​()` | Ends the document.
    `void` | `endElement​()` | Ends the current element.
    `Renderer` | `getRenderer​()` | Returns the renderer.
    `void` | `handlePageBreak​(CSSValue pageName, PseudoPage[] pseudoPages)` |
    `State` | `saveState​()` |
    `void` | `startDocument​()` | Start document is the first call to the normalizer.
    `void` | `startElement​(java.lang.String namespace, java.lang.String tag, AttributeMap attributes)` | Starts a new element.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ChainingNormalizer

          public ChainingNormalizer​(Normalizer normalizer)

  - ### Method Detail

    - #### startDocument

          public void startDocument​()
                             throws NormalizationException,
                                    java.io.IOException

      Start document is the first call to the normalizer. At this point, all meta-data has been given and the document context is filled correctly.

      Starting the document also starts a new PageContext.
      Specified by:
        `startDocument` in interface `Normalizer`
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### commitCalls

          public void commitCalls​()
                           throws NormalizationException

      Throws:
        `NormalizationException`

    - #### startElement

          public void startElement​(java.lang.String namespace,
                                   java.lang.String tag,
                                   AttributeMap attributes)
                            throws NormalizationException,
                                   java.io.IOException

      Starts a new element. The element uses the given namespace and tagname. The element's attributes are given as collection, each attribute is keyed with a namespace and attributename. The values contained in the attributes are not defined.
      Specified by:
        `startElement` in interface `Normalizer`
      Parameters:
        `namespace` -
        `tag` -
        `attributes` -
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### addText

          public void addText​(java.lang.String text)
                       throws NormalizationException,
                              java.io.IOException

      Adds text content to the current element.
      Specified by:
        `addText` in interface `Normalizer`
      Parameters:
        `text` -
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### endElement

          public void endElement​()
                          throws NormalizationException,
                                 java.io.IOException

      Ends the current element. The namespace and tagname are given for convienience.
      Specified by:
        `endElement` in interface `Normalizer`
      Parameters:
        `namespace` -
        `tag` -
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### endDocument

          public void endDocument​()
                           throws NormalizationException,
                                  java.io.IOException

      Ends the document. No other events will be fired against this normalizer once this method has been called.
      Specified by:
        `endDocument` in interface `Normalizer`
      Throws:
        `NormalizationException`
        `java.io.IOException`

    - #### handlePageBreak

          public void handlePageBreak​(CSSValue pageName,
                                      PseudoPage[] pseudoPages)
                               throws NormalizationException

      Specified by:
        `handlePageBreak` in interface `Normalizer`
      Throws:
        `NormalizationException`

    - #### saveState

          public State saveState​()
                          throws StateException

      Specified by:
        `saveState` in interface `StatefullComponent`
      Throws:
        `StateException`

    - #### getRenderer

          public Renderer getRenderer​()

      Returns the renderer. The renderer is the last step in the processing chain. The ModelBuilder and ContentGenerator steps are considered internal, as they may refeed the normalizer.
      Specified by:
        `getRenderer` in interface `Normalizer`
      Returns: